<?php
include('log.php');
$max=4; //posti minibus
$EMAX= 3;

function userLoggedIn() {
    if (isset($_SESSION['myuser'])) {
        return ($_SESSION['myuser']);
    } else { return false; }
}

function myRedirect($page="",$msg="") {
	echo '<META HTTP-EQUIV="refresh" content="0;URL='.$page.'">';
	if($msg!=""){
		$pattern = '/ /';
		$replacement = '_';
		$str = preg_replace($pattern, $replacement, $msg);
		if(isset($_SESSION['myuser'])){
			$st=$_SESSION['myuser']."_".$str;
			error_log($st);
		}else{
			error_log($str);
		}
		
	}
    exit; // Necessario per evitare ulteriore processamento della pagina
}

function myDestroySession() {
    $_SESSION=array();
    if (ini_get("session.use_cookies")) {
        $params = session_get_cookie_params();
        setcookie(session_name(), '', time()-3600*24, $params["path"],$params["domain"], $params["secure"], $params["httponly"]);
    }
    session_unset(); // remove all session variables
    session_destroy(); // destroy session
    
	myRedirect("index.php","myDestroySession");
}

function dbConnect() {
	include "config.php";
	try {
		$db = new PDO ("$dbtype:host=$hostname;dbname=$dbname", $user, $pass);
	} catch (PDOException $e) {
		$_SESSION['msg']="Errore: " . $e->getMessage();
		myRedirect("index.php","DB connection error.");
	}
    
	return $db;
}

function myhttps(){
	  if (!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] !== 'off'){
        //Richiesta e' stata fatta gia' su HTTPS
	  }else{
        // Redirect su HTTPS ed eventuale distruzione sessione e cookie relativo
        $redirect = 'https://' . $_SERVER['HTTP_HOST'] .$_SERVER['REQUEST_URI'];
        header('HTTP/1.1 301 Moved Permanently');
        header('Location: ' . $redirect);
        exit();
    }
}

function cookieon(){
	if(!isset($_COOKIE['s252956utente'])){
		myDestroySession();
	}else{
		return htmlspecialchars($_COOKIE['s252956utente']);
	}
}
function set_cookie($utente){
		setcookie("s252956utente", $utente, time()+600, "/");
}

function myLOGOUT(){
	myDestroySession();
}

function myEmail_format($email){
	//CONTROLLO EMAIL
	$correct= false;
	$email = trim($email);//elimino spazi, "a capo" e altro alle estremita' della stringa
	// controllo che ci sia una sola @ nella stringa
	if((count(explode( '@', $email )) - 1) == 1) {
		// la stringa rispetta il formato classico di una mail?
		if(preg_match( '/^[\w\.\-]+@\w+[\w\.\-]*?\.\w{1,4}$/', $email)) {
			$correct=true;
		}
		// controllo la presenza di ulteriori caratteri "pericolosi":
		if(strpos($email,';') || strpos($email,',') || strpos($email,' ') || strpos($email,'#') || strpos($email,'!') || strpos($email,'?')) {
			$correct=false;
		}
	}
	return $correct;
}
function myEmail_registered($db,$email){ 
	$query = "SELECT * FROM utenti WHERE utente=:email FOR UPDATE";
	$stmt = $db->prepare($query);
	$stmt->bindParam(':email', $email, PDO::PARAM_STR);
	
	if(! $stmt->execute()){
		$_SESSION['msg']="DB connection error - query not executed. <br>";
		myRedirect("index.php","DB connection error");
	}

	if ($stmt->rowCount()== 1){ //l'utente e' gia' registrato
		return true;
	}
	return false;
}

function myEncrypt($str){
	$ciphering = "AES-128-CTR";
	$iv_length = openssl_cipher_iv_length($ciphering);
	$options = 0;
	$encryption_iv = random_bytes($iv_length);
	$encryption_key = openssl_digest(php_uname(), 'MD5', TRUE);
	$encryption = openssl_encrypt($str, $ciphering, $encryption_key, $options, $encryption_iv); 

	if($encryption !=FALSE){
		return $encryption;
	}
	return false;
}

function myImages($email){	//recupero le immagini associate all'utente
	$db= dbConnect();
	$query = "SELECT * FROM utenti WHERE utente=:email FOR UPDATE";
	$stmt = $db->prepare($query);
	$stmt->bindParam(':email', $email, PDO::PARAM_STR);
	if(!$risp = $stmt->execute()){
		$_SESSION['msg']="DB connection error. <br> Please retry";
		$stmt=null;
		$db=null;
		myRedirect("index.php","DB connection error");
	}
	$pimages= $stmt->fetch(PDO::FETCH_ASSOC);
	if (strcmp($pimages['utente'], $email)==0) {
		$personal_images=explode( ',', $pimages['password']);
		$stmt=null;
		$db=null;
	}else{
		$_SESSION['msg']="No secret registered for this user. <br>";
		$stmt=null;
		$db=null;
		myRedirect("index.php",$email." no secret found");
	}
	return $personal_images;
}

function register($email, $secr){ //registra user nel DB 
    $conn = dbConnect();
    $sql = "INSERT INTO utenti(utente, password) VALUES(:email,:secr)";
    $stmt = $conn->prepare($sql);
    $stmt->bindParam(':email', $email, PDO::PARAM_STR);
    $stmt->bindParam(':secr', $secr, PDO::PARAM_STR);
    
    $users = $stmt->execute();
    
    if($users) {
        $_SESSION['msg']= "Registration completed. Complete this questionnaire please.";
        $_SESSION['myuser']= $email;
        $_SESSION['username']= $email;
        $_SESSION['log'] = TRUE;
		$_SESSION['first']=TRUE;
		unset($_SESSION['rimages']);
		unset($_SESSION['remail']);
        myRedirect("questionnaire.php","_Registration completed");
    }else{
        $_SESSION['msg']= "Registration failed.<br> PLEASE RETRY to SIGN IN.<br>";
        unset($_SESSION['rimages']);
        unset($_SESSION['remail']);
        myRedirect("index.php",$email."_Registration failed");
    }
    $stmt=null;
    $conn=null;
}

function login($email, $err) {
 	global $EMAX;
	$db = dbConnect();
	$sql = "SELECT * FROM utenti WHERE utente=:email FOR UPDATE";
	$stmt = $db->prepare($sql);
	$stmt->bindParam(':email', $email, PDO::PARAM_STR);
	
	if(! $risposta = $stmt->execute()){
		$stmt=null;
		$db=null;
		$_SESSION['msg']="DB connection error. <br>Please retry.";
		myRedirect("index.php","LOGIN_DB connection error");
	}
	if ($stmt->rowCount()== 1 && $err < $EMAX) {
		$stmt=null;
		$db=null;
		$_SESSION['msg']="ERRORS COMMITTED during login: ".$err;
		$_SESSION['myuser']= $email;
		$_SESSION['username']= $email;
		$_SESSION['log'] = TRUE;
		$_SESSION['first']=TRUE;
		error_log($_SESSION['myuser']."_".$_SESSION['msg']);
		myRedirect("questionnaire_LOGIN.php","LOGIN SUCCESS with errors: ".$err);
		exit();
	}else{
		$_SESSION['msg']="LOGIN FAILED.";
		unset($_SESSION['err']);
		myRedirect("index.php",$email."_".$_SESSION['msg']."_ERRORS: ".$err);
		$stmt=null;
		$db=null;
	}
}

function myDirection($im){
	$db = dbConnect();
	$sql="SELECT * FROM images WHERE image=:im FOR UPDATE";
	$stmt = $db->prepare($sql);
	$stmt->bindParam(':im', $im, PDO::PARAM_STR);
	if (!$stmt->execute()){
		$_SESSION['msg']="DB connection error.<br> Please, retry.";
		myRedirect("index.php","QUERY FAILED - myDirection");
	}
	
	if(($t= $stmt->rowCount())==1){
		$row = $stmt->fetch(PDO::FETCH_ASSOC);
	}else{
		$_SESSION['msg']="DIRECTION NOT FOUND.";
		$stmt=null;
		$db=null;
		myRedirect("index.php","DIRECTION NOT FOUND".$im);
	}
	$stmt=null;
	$db=null;
	return $row['arrow'];
}



function myPossible($from,$to){
    if($from >= $to){
        $_SESSION['msg']="IMPOSSIBLE PATH. Try again";
        myRedirect("reservation.php", $_SESSION['msg']);
    }
    return;
}

function myResearch($from, $to,$p){   //controlla che nel tragitto indicato ci siano posti 
    $conn = dbConnect();   
    global $max;
  try{
  	$conn->beginTransaction();
    $sql="SELECT * FROM percorsi WHERE partenze>=:from AND partenze<:to FOR UPDATE";
    $stmt = $conn->prepare($sql);
    $stmt->bindParam(':from', $from, PDO::PARAM_STR);
    $stmt->bindParam(':to', $to, PDO::PARAM_STR);
    
    if (!$ris = $stmt->execute())
        throw new Exception("query fallita myResearch SELECT");
        if(($t=$stmt->rowCount())>0){
        	while($row = $stmt->fetch(PDO::FETCH_ASSOC)){
        		if(($row['totale']+ $p)>$max){
                   $_SESSION['msg']="REQUEST DENIED. <br> There is not a place for everyone.";
                   $stmt=null;
                   $conn=null;
                   myRedirect("reservation.php",$_SESSION['msg']);
               }
           }//significa che non superano il massimo -> ok=true
           $sql="UPDATE percorsi SET totale=totale+:p WHERE partenze>=:from AND partenze<:to"; 
           $stmt = $conn->prepare($sql);
           $stmt->bindParam(':from', $from, PDO::PARAM_STR);
           $stmt->bindParam(':to', $to, PDO::PARAM_STR);
           $stmt->bindParam(':p', $p, PDO::PARAM_INT);
           
           if(!$ris = $stmt->execute()){
               throw new Exception("QUERY FAILED myResearch UPDATE");
           }
           
           $sql="INSERT INTO prenotazioni(utente,partenze,arrivi,passeggeri) VALUES(:user,:from,:to,:p)";
           $stmt = $conn->prepare($sql);
           $stmt->bindParam(':user', $_SESSION['myuser'], PDO::PARAM_STR);
           $stmt->bindParam(':from', $from, PDO::PARAM_STR);
           $stmt->bindParam(':to', $to, PDO::PARAM_STR);
           $stmt->bindParam(':p', $p, PDO::PARAM_INT);
           
           if(!($ris = $stmt->execute()))
               throw new Exception("QUERY FAILED myResearch INSERT PRENOTAZIONI MIN");
           
           if (!$conn->commit()) {
               // per avere il corretto messaggio di errore
               throw Exception("Commit fallita myResearch");
           }
           //e' andato tutto bene
           $_SESSION['msg']= "Record successfully updated.";
           myRedirect("ppage.php",$_SESSION['msg']);
           
       }else{throw new Exception("No result");}
  
 }catch(Exception $e){
      $conn->rollBack();
      $_SESSION['msg'] =$e->getMessage();
      myRedirect("reservation.php",$_SESSION['msg']);
 }
 $stmt=null;
 $conn=null;
}

function myDelete(){
    $conn=dbConnect();
 try{
 	$conn->beginTransaction();
    $query="SELECT * FROM prenotazioni WHERE utente=:user  FOR UPDATE ";
    $stmt = $conn->prepare($query);
    $stmt->bindParam(':user', $_SESSION['myuser'], PDO::PARAM_STR);
    
    if(!$stmt->execute())
        throw new Exception("QUERY FAILED myDelete from prenotazioni");
    $row = $stmt->fetch(PDO::FETCH_ASSOC);//reservation utente

    if(($stmt->rowCount())>0){ 
    	$query="SELECT * FROM percorsi WHERE partenze>=:from AND partenze<:to FOR UPDATE ";
        $stmt = $conn->prepare($query);
        $stmt->bindParam(':from', $row['partenze'], PDO::PARAM_STR);
        $stmt->bindParam(':to',$row['arrivi'], PDO::PARAM_STR);
        
        if(!$stmt->execute())
            throw new Exception("QUERY FAILED myDelete from prenotazioni"); 
        while($stmt->fetch(PDO::FETCH_ASSOC)){//elenco delle tuple di quell'utente
	        $sql="UPDATE percorsi SET totale=totale-:pass WHERE partenze>=:from AND partenze<:to ";
	        $stmt = $conn->prepare($sql);
	        $stmt->bindParam(':pass', $row['passeggeri'], PDO::PARAM_STR);
	        $stmt->bindParam(':from',$row['partenze'], PDO::PARAM_STR);
	        $stmt->bindParam(':to',$row['arrivi'], PDO::PARAM_STR);
	        	
	        if (!$stmt->execute())
           		throw new Exception("QUERY FAILED myDelete update");
        }
        //devo eliminare le entry nelle tabelle prenotazioni e percorsi
        $sql="DELETE FROM prenotazioni WHERE utente=:user";
        $stmt = $conn->prepare($sql);
        $stmt->bindParam(':user', $_SESSION['myuser'], PDO::PARAM_STR);
        if (! $stmt->execute())
            throw new Exception("QUERY FAILED myDelete delete");
    }else{
        throw new Exception("No reservations to be deleted.");
    }
        
        
     if (!$conn->commit()) {// per avere il corretto messaggio di errore
        throw Exception("myDelete Commit FAILED");
     }
     //e' andato tutto bene
     $_SESSION['msg']= "RESERVATION SUCCESSFULLY DELETED.";
     $stmt=null;
     $conn=null;
     myRedirect("ppage.php",$_SESSION['msg']);
     
        
   
 }catch(Exception $e){
    $conn->rollBack();
    $_SESSION['msg'] =$e->getMessage();
    myRedirect("ppage.php",$_SESSION['msg']);
 }
}

 function myDeleteAccount(){
 	$conn=dbConnect();
 	try{
 		$conn->beginTransaction();
 		$query="SELECT * FROM utenti WHERE utente=:user FOR UPDATE ";
 		$stmt = $conn->prepare($query);
 		$stmt->bindParam(':user', $_SESSION['myuser'], PDO::PARAM_STR);
 		if(!($stmt->execute()))
 			throw new Exception("QUERY FAILED - myDeleteAccount");
 			
		if(($stmt->rowCount())==1){
		    //controls if there is a reservation
		    $query="SELECT * FROM prenotazioni WHERE utente=:user FOR UPDATE ";
		    $stmt = $conn->prepare($query);
		    $stmt->bindParam(':user', $_SESSION['myuser'], PDO::PARAM_STR);
		    if(!$stmt->execute())
		        throw new Exception("QUERY FAILED myDelete from prenotazioni");
		    
	        if(($stmt->rowCount())>0){ 
	            $_SESSION['msg']="Delete your trip before you delete your account.";
	            myRedirect("ppage.php",$_SESSION['msg']);
	        }
		 
    		$sql="DELETE FROM utenti WHERE utente=:user";
    		$stmt = $conn->prepare($sql);
    		$stmt->bindParam(':user', $_SESSION['myuser'], PDO::PARAM_STR);
    		
    		if (!$stmt->execute())
    			throw new Exception("QUERY FAILED myDeleteAccount delete");
 		}else{
 			throw new Exception("myDeleteAccount Nessun utente da eliminare.");
 		}
 		
 		if (!$conn->commit()) {
 			throw Exception("myDelete Commit FAILED");
 		}
 		//everything ok
 		$_SESSION['msg']= "Account SUCCESSFULLY DELETED.";	
 		$stmt=null;
 		$conn=null;
 		myDestroySession();
 	
 	}catch(Exception $e){
 		$conn->rollBack();
 		$_SESSION['msg'] =$e->getMessage();
 		myRedirect("ppage.php",$_SESSION['msg']);
 	}
 }
   

    
?>